@@ -458,9 +458,9 @@
 			 * shared process leaders.
 			 */
 			fdtol = p1->p_fdtol;
-			FILEDESC_LOCK_FAST(p1->p_fd);
+			FILEDESC_XLOCK(p1->p_fd);
 			fdtol->fdl_refcount++;
-			FILEDESC_UNLOCK_FAST(p1->p_fd);
+			FILEDESC_XUNLOCK(p1->p_fd);
 		} else {
 			/* 
 			 * Shared file descriptor table, and
==== //depot/vendor/freebsd/src/sys/kern/kern_idle.c#31 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_idle.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_intr.c#81 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_intr.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_jail.c#53 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_jail.c#3 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_kse.c#51 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_kse.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_kthread.c#22 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_kthread.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_ktr.c#32 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_ktr.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_ktrace.c#62 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_ktrace.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_linker.c#83 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_linker.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_lock.c#61 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_lock.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_lockf.c#26 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_lockf.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_malloc.c#68 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_malloc.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_mbuf.c#28 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_mbuf.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_mib.c#33 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_mib.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_module.c#27 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_module.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_mtxpool.c#11 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_mtxpool.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_mutex.c#119 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_mutex.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_ntptime.c#26 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_ntptime.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_physio.c#19 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_physio.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_pmc.c#6 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_pmc.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_poll.c#28 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_poll.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_priv.c#1 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_priv.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_proc.c#151 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_proc.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_prot.c#108 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_prot.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_resource.c#83 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_resource.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_rwlock.c#20 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_rwlock.c#3 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_sema.c#6 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_sema.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_shutdown.c#80 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_shutdown.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_sig.c#216 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_sig.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_subr.c#58 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_subr.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_switch.c#114 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_switch.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_sx.c#33 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_sx.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_synch.c#143 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_synch.c#3 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_syscalls.c#6 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_syscalls.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_sysctl.c#64 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_sysctl.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_tc.c#67 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_tc.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_thr.c#59 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_thr.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_thread.c#239 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_thread.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_time.c#67 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_time.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_timeout.c#36 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_timeout.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_umtx.c#59 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_umtx.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_uuid.c#12 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_uuid.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/kern_xxx.c#18 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/kern_xxx.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/ksched.c#4 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/ksched.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/link_elf.c#52 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/link_elf.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/link_elf_obj.c#18 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/link_elf_obj.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/linker_if.m#4 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/linker_if.m#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/makesyscalls.sh#24 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/makesyscalls.sh#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/md4c.c#3 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/md4c.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/md5c.c#10 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/md5c.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/p1003_1b.c#5 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/p1003_1b.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/posix4_mib.c#4 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/posix4_mib.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/sched_4bsd.c#97 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/sched_4bsd.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/sched_core.c#13 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/sched_core.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/sched_ule.c#187 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/sched_ule.c#3 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/serdev_if.m#2 (text) - //depot/user/rwatson/filedesc/src/sys/kern/serdev_if.m#1 (text) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_acl_posix1e.c#5 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_acl_posix1e.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_autoconf.c#8 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_autoconf.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_blist.c#9 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_blist.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_bus.c#107 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_bus.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_clock.c#11 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_clock.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_devstat.c#24 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_devstat.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_disk.c#48 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_disk.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_eventhandler.c#11 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_eventhandler.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_fattime.c#2 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_fattime.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_firmware.c#9 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_firmware.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_hints.c#12 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_hints.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_kdb.c#23 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_kdb.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_kobj.c#7 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_kobj.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_lock.c#13 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_lock.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_log.c#21 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_log.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_mbpool.c#3 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_mbpool.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_mchain.c#17 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_mchain.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_module.c#2 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_module.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_msgbuf.c#3 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_msgbuf.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_param.c#33 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_param.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_pcpu.c#8 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_pcpu.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_power.c#8 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_power.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_prf.c#60 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_prf.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_prof.c#32 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_prof.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_rman.c#37 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_rman.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_rtc.c#3 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_rtc.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_sbuf.c#20 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_sbuf.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_scanf.c#5 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_scanf.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_sleepqueue.c#35 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_sleepqueue.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_smp.c#43 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_smp.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_stack.c#3 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_stack.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_taskqueue.c#29 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_taskqueue.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_trap.c#96 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_trap.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_turnstile.c#34 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_turnstile.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_unit.c#7 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_unit.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/subr_witness.c#145 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/subr_witness.c#2 (text+ko) ==== content
@@ -281,7 +281,6 @@
 	 * Various mutexes
 	 */
 	{ "Giant", &lock_class_mtx_sleep },
-	{ "filedesc structure", &lock_class_mtx_sleep },
 	{ "pipe mutex", &lock_class_mtx_sleep },
 	{ "sigio lock", &lock_class_mtx_sleep },
 	{ "process group", &lock_class_mtx_sleep },
@@ -294,7 +293,6 @@
 	/*
 	 * Sockets
 	 */
-	{ "filedesc structure", &lock_class_mtx_sleep },
 	{ "accept", &lock_class_mtx_sleep },
 	{ "so_snd", &lock_class_mtx_sleep },
 	{ "so_rcv", &lock_class_mtx_sleep },
==== //depot/vendor/freebsd/src/sys/kern/sys_generic.c#75 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/sys_generic.c#4 (text+ko) ==== content
@@ -568,14 +568,14 @@
 	fdp = td->td_proc->p_fd;
 	switch (com) {
 	case FIONCLEX:
-		FILEDESC_LOCK_FAST(fdp);
+		FILEDESC_XLOCK(fdp);
 		fdp->fd_ofileflags[fd] &= ~UF_EXCLOSE;
-		FILEDESC_UNLOCK_FAST(fdp);
+		FILEDESC_XUNLOCK(fdp);
 		goto out;
 	case FIOCLEX:
-		FILEDESC_LOCK_FAST(fdp);
+		FILEDESC_XLOCK(fdp);
 		fdp->fd_ofileflags[fd] |= UF_EXCLOSE;
-		FILEDESC_UNLOCK_FAST(fdp);
+		FILEDESC_XUNLOCK(fdp);
 		goto out;
 	case FIONBIO:
 		FILE_LOCK(fp);
@@ -658,11 +658,10 @@
 		return (EINVAL);
 	fdp = td->td_proc->p_fd;
 	
-	FILEDESC_LOCK_FAST(fdp);
-
+	FILEDESC_SLOCK(fdp);
 	if (nd > td->td_proc->p_fd->fd_nfiles)
 		nd = td->td_proc->p_fd->fd_nfiles;   /* forgiving; slightly wrong */
-	FILEDESC_UNLOCK_FAST(fdp);
+	FILEDESC_SUNLOCK(fdp);
 
 	/*
 	 * Allocate just enough bits for the non-null fd_sets.  Use the
@@ -809,7 +808,7 @@
 	static int flag[3] = { POLLRDNORM, POLLWRNORM, POLLRDBAND };
 	struct filedesc *fdp = td->td_proc->p_fd;
 
-	FILEDESC_LOCK(fdp);
+	FILEDESC_SLOCK(fdp);
 	for (msk = 0; msk < 3; msk++) {
 		if (ibits[msk] == NULL)
 			continue;
@@ -820,7 +819,7 @@
 				if (!(bits & 1))
 					continue;
 				if ((fp = fget_locked(fdp, fd)) == NULL) {
-					FILEDESC_UNLOCK(fdp);
+					FILEDESC_SUNLOCK(fdp);
 					return (EBADF);
 				}
 				if (fo_poll(fp, flag[msk], td->td_ucred,
@@ -832,7 +831,7 @@
 			}
 		}
 	}
-	FILEDESC_UNLOCK(fdp);
+	FILEDESC_SUNLOCK(fdp);
 	td->td_retval[0] = n;
 	return (0);
 }
@@ -973,7 +972,7 @@
 	struct file *fp;
 	int n = 0;
 
-	FILEDESC_LOCK(fdp);
+	FILEDESC_SLOCK(fdp);
 	for (i = 0; i < nfd; i++, fds++) {
 		if (fds->fd >= fdp->fd_nfiles) {
 			fds->revents = POLLNVAL;
@@ -997,7 +996,7 @@
 			}
 		}
 	}
-	FILEDESC_UNLOCK(fdp);
+	FILEDESC_SUNLOCK(fdp);
 	td->td_retval[0] = n;
 	return (0);
 }
==== //depot/vendor/freebsd/src/sys/kern/sys_pipe.c#106 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/sys_pipe.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/sys_process.c#73 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/sys_process.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/sys_socket.c#40 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/sys_socket.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/syscalls.c#122 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/syscalls.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/syscalls.master#138 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/syscalls.master#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/systrace_args.c#12 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/systrace_args.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/sysv_ipc.c#17 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/sysv_ipc.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/sysv_msg.c#39 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/sysv_msg.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/sysv_sem.c#55 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/sysv_sem.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/sysv_shm.c#49 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/sysv_shm.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/tty.c#113 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/tty.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/tty_compat.c#11 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/tty_compat.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/tty_conf.c#8 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/tty_conf.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/tty_cons.c#48 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/tty_cons.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/tty_pts.c#13 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/tty_pts.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/tty_pty.c#64 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/tty_pty.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/tty_subr.c#10 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/tty_subr.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/tty_tty.c#25 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/tty_tty.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/uipc_accf.c#14 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/uipc_accf.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/uipc_cow.c#26 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/uipc_cow.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/uipc_debug.c#1 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/uipc_debug.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/uipc_domain.c#25 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/uipc_domain.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/uipc_mbuf.c#84 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/uipc_mbuf.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/uipc_mbuf2.c#25 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/uipc_mbuf2.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/uipc_mqueue.c#19 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/uipc_mqueue.c#4 (text+ko) ==== content
@@ -2013,10 +2013,10 @@
 	fp->f_data = pn;
 	FILE_UNLOCK(fp);
 
-	FILEDESC_LOCK_FAST(fdp);
+	FILEDESC_XLOCK(fdp);
 	if (fdp->fd_ofiles[fd] == fp)
 		fdp->fd_ofileflags[fd] |= UF_EXCLOSE;
-	FILEDESC_UNLOCK_FAST(fdp);
+	FILEDESC_XUNLOCK(fdp);
 	td->td_retval[0] = fd;
 	fdrop(fp, td);
 	return (0);
@@ -2197,14 +2197,14 @@
 	if (error)
 		return (error);
 again:
-	FILEDESC_LOCK_FAST(fdp);
+	FILEDESC_SLOCK(fdp);
 	if (fget_locked(fdp, uap->mqd) != fp) {
-		FILEDESC_UNLOCK_FAST(fdp);
+		FILEDESC_SUNLOCK(fdp);
 		error = EBADF;
 		goto out;
 	}
 	mtx_lock(&mq->mq_mutex);
-	FILEDESC_UNLOCK_FAST(fdp);
+	FILEDESC_SUNLOCK(fdp);
 	if (uap->sigev != NULL) {
 		if (mq->mq_notifier != NULL) {
 			error = EBUSY;
@@ -2267,7 +2267,8 @@
 	struct mqueue *mq;
  
 	fdp = td->td_proc->p_fd;
-	FILEDESC_LOCK_ASSERT(fdp, MA_OWNED);
+	FILEDESC_LOCK_ASSERT(fdp);
+
 	if (fp->f_ops == &mqueueops) {
 		mq = FPTOMQ(fp);
 		mtx_lock(&mq->mq_mutex);
@@ -2295,7 +2296,7 @@
 	int i;
 
 	fdp = p->p_fd;
-	FILEDESC_LOCK_FAST(fdp);
+	FILEDESC_SLOCK(fdp);
 	for (i = 0; i < fdp->fd_nfiles; ++i) {
 		fp = fget_locked(fdp, i);
 		if (fp != NULL && fp->f_ops == &mqueueops) {
@@ -2305,7 +2306,7 @@
 			mtx_unlock(&mq->mq_mutex);
 		}
 	}
-	FILEDESC_UNLOCK_FAST(fdp);
+	FILEDESC_SUNLOCK(fdp);
 	KASSERT(LIST_EMPTY(&p->p_mqnotifier), ("mq notifiers left"));
 }
 
==== //depot/vendor/freebsd/src/sys/kern/uipc_sem.c#28 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/uipc_sem.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/uipc_sockbuf.c#6 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/uipc_sockbuf.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/uipc_socket.c#194 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/uipc_socket.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/uipc_socket2.c#90 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/uipc_socket2.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/uipc_syscalls.c#153 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/uipc_syscalls.c#3 (text+ko) ==== content
@@ -124,7 +124,7 @@
 	if (fdp == NULL)
 		error = EBADF;
 	else {
-		FILEDESC_LOCK_FAST(fdp);
+		FILEDESC_SLOCK(fdp);
 		fp = fget_locked(fdp, fd);
 		if (fp == NULL)
 			error = EBADF;
@@ -137,7 +137,7 @@
 				*fflagp = fp->f_flag;
 			error = 0;
 		}
-		FILEDESC_UNLOCK_FAST(fdp);
+		FILEDESC_SUNLOCK(fdp);
 	}
 	*fpp = fp;
 	return (error);
@@ -182,12 +182,17 @@
 	if (error) {
 		fdclose(fdp, fp, fd, td);
 	} else {
-		FILEDESC_LOCK_FAST(fdp);
+		/*
+		 * XXXRW: The logic here seems wrong -- shouldn't it be
+		 * locking the file, not the filedesc?  Other threads could
+		 * already have a reference to the socket by now.
+		 */
+		FILEDESC_XLOCK(fdp);
 		fp->f_data = so;	/* already has ref count */
 		fp->f_flag = FREAD|FWRITE;
 		fp->f_ops = &socketops;
 		fp->f_type = DTYPE_SOCKET;
-		FILEDESC_UNLOCK_FAST(fdp);
+		FILEDESC_XUNLOCK(fdp);
 		td->td_retval[0] = fd;
 	}
 	fdrop(fp, td);
==== //depot/vendor/freebsd/src/sys/kern/uipc_usrreq.c#134 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/uipc_usrreq.c#3 (text+ko) ==== content
@@ -1579,10 +1579,10 @@
 				unp_freerights(rp, newfds);
 				goto next;
 			}
-			FILEDESC_LOCK(td->td_proc->p_fd);
+			FILEDESC_XLOCK(td->td_proc->p_fd);
 			/* if the new FD's will not fit free them.  */
 			if (!fdavail(td, newfds)) {
-				FILEDESC_UNLOCK(td->td_proc->p_fd);
+				FILEDESC_XUNLOCK(td->td_proc->p_fd);
 				error = EMSGSIZE;
 				unp_freerights(rp, newfds);
 				goto next;
@@ -1597,7 +1597,7 @@
 			*controlp = sbcreatecontrol(NULL, newlen,
 			    SCM_RIGHTS, SOL_SOCKET);
 			if (*controlp == NULL) {
-				FILEDESC_UNLOCK(td->td_proc->p_fd);
+				FILEDESC_XUNLOCK(td->td_proc->p_fd);
 				error = E2BIG;
 				unp_freerights(rp, newfds);
 				goto next;
@@ -1616,7 +1616,7 @@
 				unp_rights--;
 				*fdp++ = f;
 			}
-			FILEDESC_UNLOCK(td->td_proc->p_fd);
+			FILEDESC_XUNLOCK(td->td_proc->p_fd);
 		} else {
 			/* We can just copy anything else across. */
 			if (error || controlp == NULL)
@@ -1738,23 +1738,24 @@
 			 * files.  If not, reject the entire operation.
 			 */
 			fdp = data;
-			FILEDESC_LOCK(fdescp);
+			FILEDESC_SLOCK(fdescp);
 			for (i = 0; i < oldfds; i++) {
 				fd = *fdp++;
 				if ((unsigned)fd >= fdescp->fd_nfiles ||
 				    fdescp->fd_ofiles[fd] == NULL) {
-					FILEDESC_UNLOCK(fdescp);
+					FILEDESC_SUNLOCK(fdescp);
 					error = EBADF;
 					goto out;
 				}
 				fp = fdescp->fd_ofiles[fd];
 				if (!(fp->f_ops->fo_flags & DFLAG_PASSABLE)) {
-					FILEDESC_UNLOCK(fdescp);
+					FILEDESC_SUNLOCK(fdescp);
 					error = EOPNOTSUPP;
 					goto out;
 				}
 
 			}
+
 			/*
 			 * Now replace the integer FDs with pointers to
 			 * the associated global file table entry..
@@ -1763,7 +1764,7 @@
 			*controlp = sbcreatecontrol(NULL, newlen,
 			    SCM_RIGHTS, SOL_SOCKET);
 			if (*controlp == NULL) {
-				FILEDESC_UNLOCK(fdescp);
+				FILEDESC_SUNLOCK(fdescp);
 				error = E2BIG;
 				goto out;
 			}
@@ -1780,7 +1781,7 @@
 				FILE_UNLOCK(fp);
 				unp_rights++;
 			}
-			FILEDESC_UNLOCK(fdescp);
+			FILEDESC_SUNLOCK(fdescp);
 			break;
 
 		case SCM_TIMESTAMP:
==== //depot/vendor/freebsd/src/sys/kern/vfs_acl.c#2 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/vfs_acl.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/vfs_aio.c#133 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/vfs_aio.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/vfs_bio.c#234 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/vfs_bio.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/vfs_cache.c#49 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/vfs_cache.c#3 (text+ko) ==== content
@@ -717,10 +717,10 @@
 	tmpbuf = malloc(buflen, M_TEMP, M_WAITOK);
 	fdp = td->td_proc->p_fd;
 	mtx_lock(&Giant);
-	FILEDESC_LOCK(fdp);
+	FILEDESC_SLOCK(fdp);
 	error = vn_fullpath1(td, fdp->fd_cdir, fdp->fd_rdir, tmpbuf,
 	    &bp, buflen);
-	FILEDESC_UNLOCK(fdp);
+	FILEDESC_SUNLOCK(fdp);
 	mtx_unlock(&Giant);
 
 	if (!error) {
@@ -771,9 +771,9 @@
 
 	buf = malloc(MAXPATHLEN, M_TEMP, M_WAITOK);
 	fdp = td->td_proc->p_fd;
-	FILEDESC_LOCK(fdp);
+	FILEDESC_SLOCK(fdp);
 	error = vn_fullpath1(td, vn, fdp->fd_rdir, buf, retbuf, MAXPATHLEN);
-	FILEDESC_UNLOCK(fdp);
+	FILEDESC_SUNLOCK(fdp);
 
 	if (!error)
 		*freebuf = buf;
==== //depot/vendor/freebsd/src/sys/kern/vfs_cluster.c#65 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/vfs_cluster.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/vfs_default.c#82 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/vfs_default.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/vfs_export.c#30 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/vfs_export.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/vfs_extattr.c#4 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/vfs_extattr.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/vfs_hash.c#13 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/vfs_hash.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/vfs_init.c#31 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/vfs_init.c#1 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/vfs_lookup.c#53 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/vfs_lookup.c#2 (text+ko) ==== content
@@ -184,14 +184,14 @@
 	/*
 	 * Get starting point for the translation.
 	 */
-	FILEDESC_LOCK(fdp);
+	FILEDESC_SLOCK(fdp);
 	ndp->ni_rootdir = fdp->fd_rdir;
 	ndp->ni_topdir = fdp->fd_jdir;
 
 	dp = fdp->fd_cdir;
 	vfslocked = VFS_LOCK_GIANT(dp->v_mount);
 	VREF(dp);
-	FILEDESC_UNLOCK(fdp);
+	FILEDESC_SUNLOCK(fdp);
 	for (;;) {
 		/*
 		 * Check if root directory should replace current directory.
==== //depot/vendor/freebsd/src/sys/kern/vfs_mount.c#175 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/vfs_mount.c#4 (text+ko) ==== content
@@ -1367,7 +1367,7 @@
 		panic("Cannot find root vnode");
 
 	p = td->td_proc;
-	FILEDESC_LOCK(p->p_fd);
+	FILEDESC_SLOCK(p->p_fd);
 
 	if (p->p_fd->fd_cdir != NULL)
 		vrele(p->p_fd->fd_cdir);
@@ -1379,7 +1379,7 @@
 	p->p_fd->fd_rdir = rootvnode;
 	VREF(rootvnode);
 
-	FILEDESC_UNLOCK(p->p_fd);
+	FILEDESC_SUNLOCK(p->p_fd);
 
 	VOP_UNLOCK(rootvnode, 0, td);
 }
==== //depot/vendor/freebsd/src/sys/kern/vfs_subr.c#374 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/vfs_subr.c#2 (text+ko) ==== identical
==== //depot/vendor/freebsd/src/sys/kern/vfs_syscalls.c#232 (text+ko) - //depot/user/rwatson/filedesc/src/sys/kern/vfs_syscalls.c#4 (text+ko) ==== content
@@ -715,10 +715,10 @@
 	}
 	VOP_UNLOCK(vp, 0, td);
 	VFS_UNLOCK_GIANT(vfslocked);
-	FILEDESC_LOCK_FAST(fdp);
+	FILEDESC_XLOCK(fdp);
 	vpold = fdp->fd_cdir;
 	fdp->fd_cdir = vp;
-	FILEDESC_UNLOCK_FAST(fdp);
+	FILEDESC_XUNLOCK(fdp);
 	vfslocked = VFS_LOCK_GIANT(vpold->v_mount);
 	vrele(vpold);
 	VFS_UNLOCK_GIANT(vfslocked);
@@ -767,10 +767,10 @@
 	VOP_UNLOCK(nd.ni_vp, 0, td);
 	VFS_UNLOCK_GIANT(vfslocked);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
-	FILEDESC_LOCK_FAST(fdp);
+	FILEDESC_XLOCK(fdp);
 	vp = fdp->fd_cdir;
 	fdp->fd_cdir = nd.ni_vp;
-	FILEDESC_UNLOCK_FAST(fdp);
+	FILEDESC_XUNLOCK(fdp);
 	vfslocked = VFS_LOCK_GIANT(vp->v_mount);
 	vrele(vp);
 	VFS_UNLOCK_GIANT(vfslocked);
@@ -789,7 +789,8 @@
 	struct file *fp;
 	int fd;
 
-	FILEDESC_LOCK_ASSERT(fdp, MA_OWNED);
+	FILEDESC_LOCK_ASSERT(fdp);
+
 	for (fd = 0; fd < fdp->fd_nfiles ; fd++) {
 		fp = fget_locked(fdp, fd);
 		if (fp == NULL)
@@ -905,12 +906,12 @@
 
 	VFS_ASSERT_GIANT(vp->v_mount);
 	fdp = td->td_proc->p_fd;
-	FILEDESC_LOCK(fdp);
+	FILEDESC_XLOCK(fdp);
 	if (chroot_allow_open_directories == 0 ||
 	    (chroot_allow_open_directories == 1 && fdp->fd_rdir != rootvnode)) {
 		error = chroot_refuse_vdir_fds(fdp);
 		if (error) {
-			FILEDESC_UNLOCK(fdp);
+			FILEDESC_XUNLOCK(fdp);
 			return (error);
 		}
 	}
@@ -921,7 +922,7 @@
 		fdp->fd_jdir = vp;
 		VREF(fdp->fd_jdir);
 	}
-	FILEDESC_UNLOCK(fdp);
+	FILEDESC_XUNLOCK(fdp);
 	vfslocked = VFS_LOCK_GIANT(oldvp->v_mount);
 	vrele(oldvp);
 	VFS_UNLOCK_GIANT(vfslocked);
@@ -1033,18 +1034,18 @@
 	 *
 	 * Handle the case where someone closed the file (via its file
 	 * descriptor) while we were blocked.  The end result should look
-	 * like opening the file succeeded but it was immediately closed.
-	 * We call vn_close() manually because we haven't yet hooked up
-	 * the various 'struct file' fields.
+	 * like opening the file succeeded but it was immediately closed.  We
+	 * call vn_close() manually because we haven't yet hooked up the
+	 * various 'struct file' fields.
 	 */
-	FILEDESC_LOCK(fdp);
+	FILEDESC_SLOCK(fdp);
 	FILE_LOCK(fp);
 	if (fp->f_count == 1) {
 		mp = vp->v_mount;
 		KASSERT(fdp->fd_ofiles[indx] != fp,
 		    ("Open file descriptor lost all refs"));
 		FILE_UNLOCK(fp);
-		FILEDESC_UNLOCK(fdp);
+		FILEDESC_SUNLOCK(fdp);
 		VOP_UNLOCK(vp, 0, td);
 		vn_close(vp, flags & FMASK, fp->f_cred, td);
 		VFS_UNLOCK_GIANT(vfslocked);
@@ -1061,7 +1062,7 @@
 	fp->f_seqcount = 1;
 	fp->f_type = (vp->v_type == VFIFO ? DTYPE_FIFO : DTYPE_VNODE);
 	FILE_UNLOCK(fp);
-	FILEDESC_UNLOCK(fdp);
+	FILEDESC_SUNLOCK(fdp);
 
 	VOP_UNLOCK(vp, 0, td);
 	if (flags & (O_EXLOCK | O_SHLOCK)) {
@@ -1209,10 +1210,10 @@
 		return (EEXIST);
 	} else {
 		VATTR_NULL(&vattr);
-		FILEDESC_LOCK_FAST(td->td_proc->p_fd);
+		FILEDESC_SLOCK(td->td_proc->p_fd);
 		vattr.va_mode = (mode & ALLPERMS) &
 		    ~td->td_proc->p_fd->fd_cmask;
-		FILEDESC_UNLOCK_FAST(td->td_proc->p_fd);
+		FILEDESC_SUNLOCK(td->td_proc->p_fd);
 		vattr.va_rdev = dev;
 		whiteout = 0;
 
